package com.thepattybeastlabs.ld35;

import java.awt.Color;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Random;

import com.thepattybeastlabs.core.Graphics;
import com.thepattybeastlabs.core.audio.AudioEngine;
import com.thepattybeastlabs.core.input.Input;
import com.thepattybeastlabs.ld35.actionmode.ActionMode;

public class AILevelController implements LevelController {

	private Random r=new Random();
	private List<AIAction> actions = new ArrayList<>();
	
	public void render(Level level, Graphics g, float offX, float offY, float tsize) {
		int blah = 100;
		g.setColor(Color.WHITE);
		g.setFont("Tahoma", 25);
		for(AIAction a : actions){
			g.drawString(a.getMode().getName() + " (" + a.getX() + ", "+ a.getY() +")"+ ", (" + a.getSelX() + ", "+ a.getSelY() +")", 10, blah,new Color(0,0,0,120));
			blah+=25;
		}
	}
	

	public void tick(Level level, Input in, AudioEngine ae, float delta, float offX, float offY, float tsize) {
		if(actions.size()==0){
			genActions(level);return;
		}
		if(!in.isPressed("place"))return;
		AIAction a = actions.get(0);
		actions.clear();
		a.getMode().onActivated(a.getX(), a.getY(), a.getSelX(), a.getSelY(), level);
		
		level.endTurn();
	}
	
	private void genActions(Level level){
		for(int sx = 0; sx < level.getWidth(); sx++){
			for(int sy = 0; sy < level.getHeight(); sy++){
				if(level.isSide(sx, sy, level.currentPlayer())){
					for(ActionMode m : level.modes()){
						for(int x = 0; x < level.getWidth(); x++){
							for(int y = 0; y < level.getHeight(); y++){
								if(m.canActivate(x, y, sx, sy, level)){
									actions.add(new AIAction(m, sx, sy, x, y));
								}
							}
						}
					}
				}
			}
		}
		int origin = level.currentPlayer()?level.getHeight()-1:0;
		for(AIAction a:actions){
			a.setGoodness(Math.abs(a.getY()-origin));
		}
		
		actions.sort(new Comparator<AIAction>() {
			public int compare(AIAction o1, AIAction o2) {
				return o1.getGoodness()>o2.getGoodness()?-1:o2.getGoodness()>o1.getGoodness()?1:0;
			}
		});
	}
	
	private int getDist(Level level, int x, int y, boolean dir, boolean vert){
		int dist=0;
		return dist;
	}

}
