package com.thepattybeastlabs.ld35;

import java.awt.Color;

import com.thepattybeastlabs.core.Core;
import com.thepattybeastlabs.core.Graphics;
import com.thepattybeastlabs.core.audio.AudioEngine;
import com.thepattybeastlabs.core.input.Input;

public class PlayerLevelController implements LevelController {

	private int highX, highY, selX, selY;
	private int mode;
	private boolean placing;
	
	public void render(Level level, Graphics g, float offX, float offY, float tsize) {
		if(highX>-1&&highX<level.getWidth()&&highY>-1&&highY<level.getHeight()){
			//g.setColor((((level.get(highX,highY)==null||!level.get(highX,highY).isPlayer()==level.currentPlayer())&&!level.isPlacing())||
			//		((!level.modes()[mode].canActivate(highX, highY, selX, selY, level))&&level.isPlacing()))?Color.RED:Color.WHITE, 100);
			if(!placing){
				g.setColor((((level.get(highX,highY)==null||!level.get(highX,highY).isPlayer()==level.currentPlayer())))?Color.RED:Color.WHITE, 100);
			}else{
				g.setColor(((!level.modes()[mode].canActivate(highX, highY, selX, selY, level)))?Color.RED:Color.WHITE, 100);
			}
			g.fillRect(highX*tsize+offX, highY*tsize, tsize, tsize);
		}
		for(int x = 0; x < level.getWidth(); x++){
			for(int y = 0; y < level.getHeight(); y++){
				if(placing&&level.modes()[mode].canActivate(x, y, selX, selY, level)){
					g.setColor(Color.GREEN);
					g.drawRect(x*tsize+offX, y*tsize, tsize, tsize);
				}
			}
		}
		g.setColor(Color.WHITE);
		g.setTextAlign(2, 2);
		g.setFont("Tahoma", 30);
		g.drawString("Mode: " + level.modes()[mode].getName(), Core.width, Core.height);
		g.setTextAlign(0, 0);
	}

	public void tick(Level level, Input in, AudioEngine ae, float delta, float offX, float offY, float tsize) {
		highX=(int)((in.getX()-(int)offX)/tsize);highY=(int)(in.getY()/tsize);
		if(in.getX()<0||in.getY()<0){
			highX=-1;highY=-1;
		}
		if(in.isPressed("cancel"))placing=false;
		if(in.isPressed("place")&&!placing&&level.get(highX, highY)!=null&&level.get(highX, highY).isPlayer()==level.currentPlayer()){
			placing=true;
			selX=highX;
			selY=highY;
		}else if(in.isPressed("place")&&placing&&level.modes()[mode].canActivate(highX, highY, selX, selY, level)){
			placing=false;
			level.modes()[mode].onActivated(highX, highY, selX, selY, level);
			level.endTurn();
		}
		mode+=in.getAxis("mode");
		if(mode>=level.modes().length)mode=0;
		if(mode<0)mode=level.modes().length-1;
		
	}

}
