package com.thepattybeastlabs.ld35.actionmode;

import java.awt.Point;
import java.util.Stack;

import com.thepattybeastlabs.ld35.Level;

public class AttackActionMode implements ActionMode{

	private Stack<Point> countPointStack = new Stack<>();
	
	public String getName() {
		return "Attack";
	}

	public boolean canActivate(float x, float y, float selX, float selY, Level level) {
		if(level.get((int)selX,(int)selY)==null)return false;
		int range = level.get((int)selX,(int)selY).getRange()+1;
		int removeCount=level.get((int)selX,(int)selY).getLevel()+1;
		if((x-selX==0||y-selY==0)&&!(x-selX==0&&y-selY==0)&&(Math.abs(x-selX)<range&&Math.abs(y-selY)<range)){
			if(level.get((int)x, (int)y)==null||level.get((int)x, (int)y).isPlayer()==level.currentPlayer())return false;
			boolean vert =  x-selX==0;
			if(!clear(level,vert?(y-selY>0):(x-selX>0),vert?y:x,vert?selY:selX,vert?selX:selY, vert))return false;
			countPointStack.push(new Point((int)x,(int)y));
			if(lookupCount(level, (int)x-1, (int)y, countPointStack)>removeCount)return false;
			if(lookupCount(level, (int)x+1, (int)y, countPointStack)>removeCount)return false;
			if(lookupCount(level, (int)x, (int)y-1, countPointStack)>removeCount)return false;
			if(lookupCount(level, (int)x, (int)y+1, countPointStack)>removeCount)return false;
			countPointStack.pop();
			return true;
		}
		return false;
	}
	
	private boolean clear(Level level, boolean dir, float start, float end, float loc, boolean vert){
		for(int i = (int)start+(dir?-1:1); dir?(i > (int)end):(i < (int)end); i+=dir?-1:1){
			if(level.get(vert?(int)loc:i, vert?i:(int)loc)!=null)return false;
		}
		return true;
	}
	
	private int lookupCount(Level level, int x, int y, Stack<Point> existing){
		int count = 1;
		if(!level.isSide(x, y,!level.currentPlayer()))return 0;
		if(y==(level.currentPlayer()?0:level.getHeight()-1))return -2000;
		if(existing.contains(new Point(x,y)))return 0;
		existing.push(new Point(x,y));
		if(level.isSide(x-1, y,!level.currentPlayer())){
			int tc = lookupCount(level, x-1, y, existing);
			//if(tc==-1)return-1;
			count+=tc;
		}
		if(level.isSide(x+1, y,!level.currentPlayer())){
			int tc = lookupCount(level, x+1, y, existing);
			//if(tc==-1)return-1;
			count+=tc;
		}
		if(level.isSide(x, y-1,!level.currentPlayer())){
			int tc = lookupCount(level, x, y-1, existing);
			//if(tc==-1)return-1;
			count+=tc;
		}
		if(level.isSide(x, y+1,!level.currentPlayer())){
			int tc = lookupCount(level, x, y+1, existing);
			//if(tc==-1)return-1;
			count+=tc;
		}
		existing.pop();
		return count;
	}
	
	private void lset(Level level, int x, int y, int ignoreX, int ignoreY){
		//System.out.println(level.currentPlayer());
		if(x==ignoreX&&y==ignoreY)return;
		level.set((int)x, (int)y, null);
		if(level.isSide(x-1, y,!level.currentPlayer()))lset(level,x-1,y, ignoreX, ignoreY);
		if(level.isSide(x+1, y,!level.currentPlayer()))lset(level,x+1,y, ignoreX, ignoreY);
		if(level.isSide(x, y-1,!level.currentPlayer()))lset(level,x,y-1, ignoreX, ignoreY);
		if(level.isSide(x, y+1,!level.currentPlayer()))lset(level,x,y+1, ignoreX, ignoreY);
	}

	@Override
	public boolean onActivated(float x, float y, float selX, float selY, Level level) {
		level.set((int)x, (int)y, null);
		countPointStack.push(new Point((int)x, (int)y));
		System.out.println(lookupCount(level, (int)x-1, (int)y, countPointStack)+", "+lookupCount(level, (int)x+1, (int)y, countPointStack)+" | " +
				lookupCount(level, (int)x, (int)y-1, countPointStack)+", "+lookupCount(level, (int)x, (int)y+1, countPointStack));
		if(lookupCount(level, (int)x-1, (int)y, countPointStack)>0)lset(level,(int) x-1, (int)y,(int) x, (int)y);
		if(lookupCount(level, (int)x+1, (int)y, countPointStack)>0)lset(level,(int) x+1, (int)y,(int) x, (int)y);
		if(lookupCount(level, (int)x, (int)y-1, countPointStack)>0)lset(level,(int) x, (int)y-1,(int) x, (int)y);
		if(lookupCount(level, (int)x, (int)y+1, countPointStack)>0)lset(level,(int) x, (int)y+1,(int) x, (int)y);
		countPointStack.pop();
		return false;
	}

}
