package com.thepattybeastlabs.ld35.actionmode;

import com.thepattybeastlabs.ld35.Level;
import com.thepattybeastlabs.ld35.Tile;

public class PlaceActionMode implements ActionMode {

	@Override
	public String getName() {
		return "Place";
	}

	@Override
	public boolean canActivate(float x, float y, float selX, float selY, Level level) {
		if(!level.canPlace())return false;
		if(level.get((int)x, (int)y)!=null)return false ;
		float dx=x-selX,dy=y-selY;
		if((dx!=0&&dy!=0)||(dx==0&&dy==0))return false;
		if(Math.abs(dx)>1||Math.abs(dy)>1)return false;
		return true;
	}

	@Override
	public boolean onActivated(float x, float y, float selX, float selY, Level level) {
		level.set((int)x, (int)y, new Tile(level.currentPlayer(),0));
		return false;
	}

}
